diff --git a/.github/workflows/publish-docker-e2e-service.yaml b/.github/workflows/publish-docker-e2e-service.yaml
new file mode 100644
index 0000000000..e3abdb54ef
--- /dev/null
+++ b/.github/workflows/publish-docker-e2e-service.yaml
@@ -0,0 +1,63 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+name: Publish E2E service images
+
+on:
+ push:
+ branches:
+ - master
+ paths:
+ - 'test/e2e-v2/java-test-service/**'
+ - 'test/Makefile'
+
+env:
+ SKIP_TEST: true
+ HUB: ghcr.io/apache/skywalking
+
+jobs:
+ build:
+ if: github.repository == 'apache/skywalking'
+ runs-on: ubuntu-latest
+ permissions:
+ contents: read
+ packages: write
+ timeout-minutes: 90
+ env:
+ TAG: ${{ github.sha }}
+ steps:
+ - uses: actions/checkout@v2
+ with:
+ submodules: true
+ - name: Cache local Maven repository
+ uses: actions/cache@v2
+ with:
+ path: ~/.m2/repository
+ key: ${{ runner.os }}-maven-${{ hashFiles('**/pom.xml') }}
+ restore-keys: |
+ ${{ runner.os }}-maven-
+ - name: Log in to the Container registry
+ uses: docker/login-action@v1.10.0
+ with:
+ registry: ${{ env.HUB }}
+ username: ${{ github.actor }}
+ password: ${{ secrets.GITHUB_TOKEN }}
+ - name: Set up QEMU
+ uses: docker/setup-qemu-action@v1
+ - name: Set up Docker Buildx
+ uses: docker/setup-buildx-action@v1
+ - name: Build and push images
+ run: make -C test build.e2e-service docker.push-e2e-service
diff --git a/Makefile b/Makefile
index de38f9738e..f18e728066 100644
--- a/Makefile
+++ b/Makefile
@@ -86,4 +86,4 @@ define DOCKER_RULE
-t $(HUB)/$(NAME):latest \
$(DOCKER_BUILD_TOP)/$(NAME)
docker buildx rm skywalking_main || true
-endef
+endef
\ No newline at end of file
diff --git a/test/Makefile b/test/Makefile
new file mode 100644
index 0000000000..e50dffeb01
--- /dev/null
+++ b/test/Makefile
@@ -0,0 +1,75 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+SHELL := /bin/bash -o pipefail
+SW_ROOT := $(shell dirname $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST)))))
+CONTEXT := $(SW_ROOT)/test/e2e-v2/java-test-service
+DOCKER_BUILD_TOP:=${SW_ROOT}/dist/docker_build
+HUB ?= ghcr.io/apache/skywalking
+TAG ?= latest
+JRE ?= 8u322-b06-jre-focal
+BASE_IMAGE ?= eclipse-temurin:$(JRE)
+
+E2E_SERVICE_PROVIDER_NAME = e2e-service-provider
+E2E_SERVICE_CONSUMER_NAME = e2e-service-consumer
+
+.PHONY: init
+init:
+ cd $(SW_ROOT) && git submodule update --init --recursive
+
+.PHONY: build.e2e-service
+build.e2e-service:
+ cd $(SW_ROOT) && ./mvnw --batch-mode -f $(CONTEXT)/pom.xml clean package
+
+DOCKER_TARGETS:=docker.e2e-service-provider docker.e2e-service-consumer
+
+.PHONY: docker docker.e2e-service
+docker: init build.e2e-service docker.e2e-service
+
+%.e2e-service-provider: NAME = $(E2E_SERVICE_PROVIDER_NAME)
+%.e2e-service-consumer: NAME = $(E2E_SERVICE_CONSUMER_NAME)
+
+docker.%: PLATFORMS =
+docker.%: LOAD_OR_PUSH = --load
+push.%: PLATFORMS = --platform linux/amd64,linux/arm64
+push.%: LOAD_OR_PUSH = --push
+
+push.docker.e2e-service-% docker.e2e-service-%: $(CONTEXT)/Dockerfile
+ $(DOCKER_RULE)
+
+docker.e2e-service: $(DOCKER_TARGETS)
+docker.push-e2e-service: $(DOCKER_TARGETS:%=push.%)
+
+# $^ the name of the dependencies for the target
+# Rule Steps #
+##############
+# 1. Make a directory $(DOCKER_BUILD_TOP)/$(NAME)
+# 2. This rule uses cp to copy all dependency filenames into into $(DOCKER_BUILD_TOP/$(NAME)
+# 3. This rule finally runs docker build passing $(BUILD_ARGS) to docker if they are specified as a dependency variable
+
+define DOCKER_RULE
+ mkdir -p $(DOCKER_BUILD_TOP)/$(NAME)
+ cp -r $^ $(SW_ROOT)/test/e2e-v2/java-test-service/$(NAME)/target/$(NAME)-2.0.0.jar $(DOCKER_BUILD_TOP)/$(NAME)
+ docker buildx create --use --driver docker-container --name skywalking_test_service > /dev/null 2>&1 || true
+ docker buildx build $(PLATFORMS) $(LOAD_OR_PUSH) \
+ --no-cache \
+ --build-arg SERVICE_JAR="./$(NAME)-2.0.0.jar" \
+ --build-arg BASE_IMAGE=$(BASE_IMAGE) \
+ -t $(HUB)/$(NAME):$(TAG) \
+ -t $(HUB)/$(NAME):latest \
+ $(DOCKER_BUILD_TOP)/$(NAME)
+ docker buildx rm skywalking_test_service || true
+endef
\ No newline at end of file
diff --git a/test/e2e-v2/java-test-service/Dockerfile b/test/e2e-v2/java-test-service/Dockerfile
new file mode 100644
index 0000000000..bc01b53c21
--- /dev/null
+++ b/test/e2e-v2/java-test-service/Dockerfile
@@ -0,0 +1,23 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+ARG BASE_IMAGE
+FROM $BASE_IMAGE
+ARG SERVICE_JAR
+
+COPY $SERVICE_JAR /app.jar
+
+CMD ["java", "-jar", "/app.jar"]
\ No newline at end of file
diff --git a/test/e2e-v2/java-test-service/e2e-protocol/pom.xml b/test/e2e-v2/java-test-service/e2e-protocol/pom.xml
index e5512ec1a6..868fc6215a 100644
--- a/test/e2e-v2/java-test-service/e2e-protocol/pom.xml
+++ b/test/e2e-v2/java-test-service/e2e-protocol/pom.xml
@@ -30,9 +30,9 @@
e2e-protocol
- 1.14.0
+ 1.43.2
1.5.0.Final
- 0.5.0
+ 0.6.1
@@ -78,10 +78,10 @@
protobuf-java directly, you will be transitively depending on the
protobuf-java version that grpc depends on.
-->
- com.google.protobuf:protoc:3.3.0:exe:${os.detected.classifier}
+ com.google.protobuf:protoc:3.19.2:exe:${os.detected.classifier}
grpc-java
- io.grpc:protoc-gen-grpc-java:1.8.0:exe:${os.detected.classifier}
+ io.grpc:protoc-gen-grpc-java:1.42.1:exe:${os.detected.classifier}